<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="标题:" prop="actTitle">
          <el-input v-model="formData.actTitle" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="开始时间:" prop="startTime">
          <el-input v-model.number="formData.startTime" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="结束时间:" prop="endTime">
          <el-input v-model.number="formData.endTime" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="分配方式:" prop="type">
          <el-select v-model="formData.type" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_act_typeOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="主链:" prop="chain">
          <el-input v-model="formData.chain" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="奖励类型:" prop="rewardType">
          <el-select v-model="formData.rewardType" placeholder="请选择" :clearable="true">
            <el-option v-for="(item,key) in twi_reward_typeOptions" :key="key" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="币种:" prop="rewardCoin">
          <el-input v-model="formData.rewardCoin" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="奖励总数:" prop="rewardAmount">
          <el-input v-model.number="formData.rewardAmount" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="人数:" prop="rewardPerson">
          <el-input v-model.number="formData.rewardPerson" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="black字段:" prop="black">
          <el-input v-model="formData.black" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="white字段:" prop="white">
          <el-input v-model="formData.white" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="showPicture字段:" prop="showPicture">
          <el-input v-model="formData.showPicture" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'TwiActList'
}
</script>

<script setup>
import {
  createTwiActList,
  updateTwiActList,
  findTwiActList
} from '@/api/twiActList'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const twi_act_typeOptions = ref([])
const twi_reward_typeOptions = ref([])
const formData = ref({
            actTitle: '',
            startTime: 0,
            endTime: 0,
            type: undefined,
            chain: '',
            rewardType: undefined,
            rewardCoin: '',
            rewardAmount: 0,
            rewardPerson: 0,
            black: '',
            white: '',
            showPicture: '',
        })
// 验证规则
const rule = reactive({
               actTitle : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               startTime : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               endTime : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               type : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               chain : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               rewardType : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findTwiActList({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.retwiActList
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
    twi_act_typeOptions.value = await getDictFunc('twi_act_type')
    twi_reward_typeOptions.value = await getDictFunc('twi_reward_type')
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createTwiActList(formData.value)
               break
             case 'update':
               res = await updateTwiActList(formData.value)
               break
             default:
               res = await createTwiActList(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
